import pygame, data, util, sys
from Map import Map
from Player import Player





class Game():
    def __init__(self):
        self.screen    = pygame.display.set_mode((util.SCREENWIDTH, util.SCREENHEIGTH))

        self.estate = 'menu'
        self.menuSound = pygame.mixer.Sound(data.filepath('1.wav', 'sounds'))

        self.levelIndex = 0
        self.tinyFont = pygame.font.Font(data.filepath('terminal.fon', 'fonts'), 100)

        self.history = []
        self.history.append(util.loadImage(data.imagepath('history1.png')))
        self.history.append(util.loadImage(data.imagepath('history2.png')))
        self.historyIndex = 0
        
        # no time to fix bugs
        self.history.append(util.loadImage(data.imagepath('history2.png')))
        self.history.append(util.loadImage(data.imagepath('history2.png')))

    def startGame(self, levelIndex, playerEstate):
        self.map = Map(levelIndex, self)
        self.map.initial(self.screen, playerEstate)

        self.map.update(self.screen)
        self.estate = 'playing'

    def mainMenu(self):
        bg = pygame.image.load(data.imagepath('bg.png'))
        self.screen.blit(bg, (0,0))

        buttons =  pygame.mouse.get_pressed()        
        pos = pygame.mouse.get_pos()

        # play button pos
        p1,p2 = (550,350), (750, 425)
        if util.mouseInRange(p1,p2,pos):
            # self.menuSound.play()
            if buttons[0] == 1:
                self.estate = 'stargame'

        # Quit button pos    
        p1,p2 = (600,500), (750, 550)
        if util.mouseInRange(p1,p2,pos):
            # self.menuSound.play()
            if buttons[0] == 1:
                self.exit()

        if pygame.key.get_pressed()[pygame.K_RETURN]:
            self.estate = 'stargame'

    def gameOver(self):
        bg = pygame.image.load(data.imagepath('background.png'))
        self.screen.blit(bg, (0,0))
        bigFont = pygame.font.Font(data.filepath('cfd.ttf', 'fonts'), 150)
        smallFont = pygame.font.Font(data.filepath('cfd.ttf', 'fonts'), 40)

        GOText = bigFont.render('Game Over', 0, (255,255,255))
        contText = smallFont.render('press space to continue', 0, (255,255,255))
        self.screen.blit(GOText, util.getTileCoords(2,2))
        self.screen.blit(contText, util.getTileCoords(2,10))


        if pygame.key.get_pressed()[pygame.K_SPACE]:
            self.map.player.lifes = 3
            self.startGame(self.map.levelIndex, self.map.player)

    def showHistory(self):

        self.screen.blit(self.history[self.historyIndex], (0,0))
        if pygame.key.get_pressed()[pygame.K_RETURN]:
            self.historyIndex += 1

        





    def update(self):
        if self.estate == 'menu':
            self.mainMenu()

        elif self.estate == 'stargame':
            if self.historyIndex < 4 :
               self.showHistory()
                
            else:
                playerEstate = Player((0,0))
                self.startGame(self.levelIndex, playerEstate)

        elif self.estate == 'playing':          
            bg = pygame.image.load(data.imagepath('bg.png'))
            self.screen.blit(bg, (0,0))
            self.map.update(self.screen)
            coins = self.tinyFont.render(' X ' + str(self.map.player.coins), 0 , (255,255,0) )
            x,y  = util.getTileCoords(30,0)
            self.screen.blit(coins, (x - 10,y +10))


        elif self.estate == 'gameOver':
            self.gameOver()

        elif self.estate == 'gameWon':
            self.gameWon()



    def gameWon(self):
        won = pygame.image.load(data.imagepath('won.png'))
        self.screen.blit(won, (0,0))


    def exit(self):
        pygame.quit()
        sys.exit()


