import pygame, data
from pygame.locals import RLEACCEL

SCREENWIDTH = 1024
SCREENHEIGTH = 704
TILESIZE = 32
TILESX = 32
TILESY = 22



def loadImage(filename, transparent=False, alpha=False, pixel=(0,0) ):
    try: image = pygame.image.load(data.imagepath(filename))
    except pygame.error, message:
        raise SystemExit, message
    if not alpha:
        image = image.convert()
    else:
        image = image.convert_alpha()
    if transparent:
        color = image.get_at(pixel)
        image.set_colorkey(color, RLEACCEL)
    return image

def cutKarakter(imagepath, rows, cols):
    image = loadImage(imagepath, True, True)
    rect  = image.get_rect()
    w = rect.w / cols
    h = rect.h / rows
    # try to create a bidimentional Array (matriz)
    sprite = range(rows)
    for i in range(rows):
        sprite[i] = range(cols)

    for r in range(rows):
        for c in range(cols):
            sprite[r][c] = image.subsurface((rect.left, rect.top, w, h))
            rect.left += w
        rect.top += h
        rect.left = 0

    return sprite

def getTileCoords(x, y):
    px = TILESIZE * x
    py = TILESIZE * y
    return px, py


def mouseInRange(p1,p2, maousePos):
    x1,y1 = p1
    x2,y2 = p2
    mx,my = maousePos
    if mx in range(x1, x2) and my in range(y1, y2):
        return True
    else:
        return False

def getLevelIndex(index):
    levels = { 'a' : 0,
               'b' : 1,
               'c' : 2,
               'd' : 3,
               'e' : 4,
               'f' : 5,
               'g' : 6,
               'h' : 7,
               'i' : 8,
               'j' : 9
    }

    return levels[index]

